<template>
  <div
    class="flex-auto overflow-y-scroll p-4 lg:p-6"
    @scroll="onContentScroll"
  >
    <slot />

    <InlineLoadingIndicator v-if="loading" />
  </div>
</template>

<script setup lang="ts">
/**
 * This is scrollable viewport that allows us to implement
 * infinite scroller. That's more convenient way to do
 * such feature since Vuetify v-infinite-scroll is a black box
 */
import { ref, watch } from 'vue';

import { CONTENT_SCROLL_BIAS } from '@/declarations';
import InlineLoadingIndicator from './InlineLoadingIndicator.vue';

defineProps<{ loading?: boolean }>();
const emit = defineEmits(['fully-scrolled']);

const isViewportScrolled = ref(false);

const onContentScroll = (event: Event) => {
  const { clientHeight, scrollTop, scrollHeight } = (
    event.target as HTMLElement
  );

  isViewportScrolled.value = (
    (scrollTop + clientHeight) >=
    (scrollHeight - CONTENT_SCROLL_BIAS)
  );
};

watch(isViewportScrolled, isViewportScrolled => {
  if (!isViewportScrolled) return;
  emit('fully-scrolled');
});
</script>